package tutorial
{
	import org.puremvc.as3.patterns.facade.Facade;
	
	import tutorial.controller.ApplicationStartupCmd;
	import tutorial.controller.LoadUsersCmd;
	import tutorial.view.Application;
	
	public class ApplicationFacade extends Facade
	{
		// Notification names
		public static const STARTUP:String = "startup";
		public static const LOADUSERS:String = "loadusers";
		public static const LOADUSERS_COMPLETE:String = "loadusers_complete";
		
		// Start the application
		public function startup(app:Application):void
		{
			sendNotification(STARTUP, app);
		}
		
		protected override function initializeController():void
		{
			super.initializeController();
			registerCommand(STARTUP, ApplicationStartupCmd);
			registerCommand(LOADUSERS, LoadUsersCmd);
		}
		
		// Singleton instance
		public static function getInstance():ApplicationFacade
		{
			if (instance == null)
				instance = new ApplicationFacade();
			return instance as ApplicationFacade;
		}
		
		// This constructor should be private, use getInstance()
		public function ApplicationFacade()
		{
			super();
		}
	}
}
